Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GaussianThompsonSamplingPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GaussianThompsonSamplingPolicy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GaussianThompsonSamplingPolicy.cs	(revision 11730)
@@ -5,15 +5,27 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
+  
   public class GaussianThompsonSamplingPolicy : BanditPolicy {
     private readonly Random random;
-    private readonly double[] sumRewards;
-    private readonly double[] sumSqrRewards;
+    private readonly double[] sampleMean;
+    private readonly double[] sampleM2;
     private readonly int[] tries;
-    public GaussianThompsonSamplingPolicy(Random random, int numActions)
+    private bool compatibility;
+
+    // assumes a Gaussian reward distribution with different means but the same variances for each action
+    // the prior for the mean is also Gaussian with the following parameters
+    private readonly double rewardVariance = 0.1; // we assume a known variance 
+
+    private readonly double priorMean = 0.5;
+    private readonly double priorVariance = 1;
+
+
+    public GaussianThompsonSamplingPolicy(Random random, int numActions, bool compatibility = false)
       : base(numActions) {
       this.random = random;
-      this.sumRewards = new double[numActions];
-      this.sumSqrRewards = new double[numActions];
+      this.sampleMean = new double[numActions];
+      this.sampleM2 = new double[numActions];
       this.tries = new int[numActions];
+      this.compatibility = compatibility;
     }
 
@@ -24,8 +36,24 @@
       int bestAction = -1;
       foreach (var a in Actions) {
-        if (tries[a] == 0) return a;
-        var mu = sumRewards[a] / tries[a];
-        var stdDev = Math.Sqrt(sumSqrRewards[a] / tries[a] - Math.Pow(mu, 2));
-        var theta = Rand.RandNormal(random) * stdDev + mu;
+        if(tries[a] == -1) continue; // skip disabled actions
+        double theta;
+        if (compatibility) {
+          if (tries[a] < 2) return a;
+          var mu = sampleMean[a];
+          var variance = sampleM2[a] / tries[a];
+          var stdDev = Math.Sqrt(variance);
+          theta = Rand.RandNormal(random) * stdDev + mu;
+        } else {
+          // calculate posterior mean and variance (for mean reward)
+
+          // see Murphy 2007: Conjugate Bayesian analysis of the Gaussian distribution (http://www.cs.ubc.ca/~murphyk/Papers/bayesGauss.pdf)
+          var posteriorVariance = 1.0 / (tries[a] / rewardVariance + 1.0 / priorVariance);
+          var posteriorMean = posteriorVariance * (priorMean / priorVariance + tries[a] * sampleMean[a] / rewardVariance);
+
+          // sample a mean from the posterior 
+          theta = Rand.RandNormal(random) * Math.Sqrt(posteriorVariance) + posteriorMean;
+
+          // theta already represents the expected reward value => nothing else to do
+        }
         if (theta > maxTheta) {
           maxTheta = theta;
@@ -33,4 +61,5 @@
         }
       }
+      Debug.Assert(Actions.Contains(bestAction));
       return bestAction;
     }
@@ -38,14 +67,14 @@
     public override void UpdateReward(int action, double reward) {
       Debug.Assert(Actions.Contains(action));
-
-      sumRewards[action] += reward;
-      sumSqrRewards[action] += reward * reward;
       tries[action]++;
+      var delta = reward - sampleMean[action];
+      sampleMean[action] += delta / tries[action];
+      sampleM2[action] += sampleM2[action] + delta * (reward - sampleMean[action]);
     }
 
     public override void DisableAction(int action) {
       base.DisableAction(action);
-      sumRewards[action] = 0;
-      sumSqrRewards[action] = 0;
+      sampleMean[action] = 0;
+      sampleM2[action] = 0;
       tries[action] = -1;
     }
@@ -53,7 +82,21 @@
     public override void Reset() {
       base.Reset();
-      Array.Clear(sumRewards, 0, sumRewards.Length);
-      Array.Clear(sumSqrRewards, 0, sumSqrRewards.Length);
+      Array.Clear(sampleMean, 0, sampleMean.Length);
+      Array.Clear(sampleM2, 0, sampleM2.Length);
       Array.Clear(tries, 0, tries.Length);
+    }
+
+    public override void PrintStats() {
+      for (int i = 0; i < sampleMean.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write(" {0,5:F2} {1}", sampleMean[i] / tries[i], tries[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return "GaussianThompsonSamplingPolicy";
     }
   }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GenericThompsonSamplingPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GenericThompsonSamplingPolicy.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/GenericThompsonSamplingPolicy.cs	(revision 11730)
@@ -0,0 +1,59 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public class GenericThompsonSamplingPolicy : BanditPolicy {
+    private readonly Random random;
+    private readonly IModel model;
+
+    public GenericThompsonSamplingPolicy(Random random, int numActions, IModel model)
+      : base(numActions) {
+      this.random = random;
+      this.model = model;
+    }
+
+    public override int SelectAction() {
+      Debug.Assert(Actions.Any());
+      var maxR = double.NegativeInfinity;
+      int bestAction = -1;
+      var expRewards = model.SampleExpectedRewards(random);
+      foreach (var a in Actions) {
+        var r = expRewards[a];
+        if (r > maxR) {
+          maxR = r;
+          bestAction = a;
+        }
+      }
+      return bestAction;
+    }
+
+    public override void UpdateReward(int action, double reward) {
+      Debug.Assert(Actions.Contains(action));
+
+      model.Update(action, reward);
+    }
+
+    public override void DisableAction(int action) {
+      base.DisableAction(action);
+      model.Disable(action);
+    }
+
+    public override void Reset() {
+      base.Reset();
+      model.Reset();
+    }
+
+    public override void PrintStats() {
+      model.PrintStats();
+    }
+
+    public override string ToString() {
+      return string.Format("GenericThompsonSamplingPolicy({0})", model);
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/RandomPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/RandomPolicy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/RandomPolicy.cs	(revision 11730)
@@ -23,5 +23,10 @@
       // do nothing
     }
-
+    public override void PrintStats() {
+      Console.WriteLine("Random");
+    }
+    public override string ToString() {
+      return "RandomPolicy";
+    }
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ThresholdAscentPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ThresholdAscentPolicy.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/ThresholdAscentPolicy.cs	(revision 11730)
@@ -0,0 +1,128 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  /* see: Streeter and Smith: A simple distribution-free approach to the max k-armed bandit problem, Proceedings  of the 12th
+ International Conference, CP 2006, Nantes, France, September 25-29, 2006. pp 560-574 */
+
+  public class ThresholdAscentPolicy : BanditPolicy {
+    const int numBins = 101;
+    const double binSize = 1.0 / (numBins - 1);
+
+    // for each arm store the number of observed rewards for each bin of size delta
+    // for delta = 0.01 we have 101 bins
+    // the first bin is freq of rewards  >= 0 // all
+    // the second bin is freq of rewards > 0
+    // the third bin is freq of rewards > 0.01
+    // the last bin is for rewards > 0.99
+    // 
+    // (also see RewardBin function)
+    private readonly int[,] armRewardHistogram; // for performance reasons we store cumulative counts (freq of rewards > lower threshold)
+
+
+    private readonly int[] tries;
+    private readonly int s;
+    private readonly double delta;
+
+    private int totalTries = 0;
+    private int thresholdBin; // bin index of current threshold
+    private const double maxTries = 1E6;
+
+    public ThresholdAscentPolicy(int numActions, int s = 100, double delta = 0.05)
+      : base(numActions) {
+      this.thresholdBin = 1; // first bin to check is bin idx 1 == freq of rewards > 0
+      this.s = s;
+      this.delta = delta;
+      this.armRewardHistogram = new int[numActions, numBins];
+      this.tries = new int[numActions];
+    }
+
+    // maps a reward value to it's bin
+    private static int RewardBin(double reward) {
+      Debug.Assert(reward >= 0 && reward <= 1.0);
+      // reward = 0 => 0
+      // ]0.00 .. 0.01] => 1
+      // ]0.01 .. 0.02] => 2
+      // ...
+      // ]0.99 .. 1.00] => 100
+      if (reward <= 0) return 0;
+      return (int)Math.Ceiling((reward / binSize));
+    }
+
+
+    private double U(double mu, int n, int k) {
+      //var alpha = Math.Log(2.0 * totalTries * k / delta);
+      double alpha = Math.Log(2) + Math.Log(maxTries) + Math.Log(k) - Math.Log(delta); // totalTries is max iterations in original paper
+      return mu + (alpha + Math.Sqrt(2 * n * mu * alpha + alpha * alpha)) / n;
+    }
+
+
+    public override int SelectAction() {
+      Debug.Assert(Actions.Any());
+      UpdateThreshold();
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
+      int k = Actions.Count();
+      foreach (var a in Actions) {
+        if (tries[a] == 0) return a;
+        double mu = armRewardHistogram[a, thresholdBin] / (double)tries[a]; // probability of rewards > T 
+        double q = U(mu, tries[a], k);
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = a;
+        }
+      }
+      Debug.Assert(Actions.Contains(bestAction));
+      return bestAction;
+    }
+
+    private void UpdateThreshold() {
+      while (thresholdBin < (numBins - 1) && Actions.Sum(a => armRewardHistogram[a, thresholdBin]) >= s) {
+        thresholdBin++;
+        // Console.WriteLine("New threshold {0:F2}", T);
+      }
+    }
+
+    public override void UpdateReward(int action, double reward) {
+      Debug.Assert(Actions.Contains(action));
+      totalTries++;
+      tries[action]++;
+      // efficiency: we can start at the current threshold bin because all bins below that are not accessed in select-action
+      for (var idx = thresholdBin; idx <= RewardBin(reward); idx++)
+        armRewardHistogram[action, idx]++;
+    }
+
+    public override void DisableAction(int action) {
+      base.DisableAction(action);
+      totalTries -= tries[action];
+      tries[action] = -1;
+    }
+
+    public override void Reset() {
+      base.Reset();
+      totalTries = 0;
+      thresholdBin = 1;
+      Array.Clear(tries, 0, tries.Length);
+      Array.Clear(armRewardHistogram, 0, armRewardHistogram.Length);
+    }
+
+    public override void PrintStats() {
+      for (int i = 0; i < tries.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write("{0,6}", tries[i]);
+        } else {
+          Console.Write("{0,6}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return string.Format("ThresholdAscentPolicy({0},{1:F2})", s, delta);
+    }
+
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1Policy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1Policy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1Policy.cs	(revision 11730)
@@ -50,4 +50,17 @@
       Array.Clear(sumReward, 0, sumReward.Length);
     }
+    public override void PrintStats() {
+      for (int i = 0; i < sumReward.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return "UCB1Policy";
+    }
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1TunedPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1TunedPolicy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCB1TunedPolicy.cs	(revision 11730)
@@ -62,4 +62,17 @@
       Array.Clear(sumSqrReward, 0, sumSqrReward.Length);
     }
+    public override void PrintStats() {
+      for (int i = 0; i < sumReward.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return "UCB1TunedPolicy";
+    }
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCBNormalPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCBNormalPolicy.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCBNormalPolicy.cs	(revision 11730)
@@ -24,8 +24,10 @@
       double bestQ = double.NegativeInfinity;
       foreach (var a in Actions) {
-        if (totalTries == 0 || tries[a] == 0 || tries[a] < Math.Ceiling(8 * Math.Log(totalTries))) return a;
+        if (totalTries <= 1 || tries[a] <= 1 || tries[a] <= Math.Ceiling(8 * Math.Log(totalTries))) return a;
         var avgReward = sumReward[a] / tries[a];
+        var estVariance = 16 * ((sumSqrReward[a] - tries[a] * Math.Pow(avgReward, 2)) / (tries[a] - 1)) * (Math.Log(totalTries - 1) / tries[a]);
+        if (estVariance < 0) estVariance = 0; // numerical problems
         var q = avgReward
-          + Math.Sqrt(16 * ((sumSqrReward[a] - tries[a] * Math.Pow(avgReward, 2)) / (tries[a] - 1)) * (Math.Log(totalTries - 1) / tries[a]));
+          + Math.Sqrt(estVariance);
         if (q > bestQ) {
           bestQ = q;
@@ -33,4 +35,5 @@
         }
       }
+      Debug.Assert(Actions.Contains(bestAction));
       return bestAction;
     }
@@ -58,4 +61,17 @@
       Array.Clear(sumSqrReward, 0, sumSqrReward.Length);
     }
+    public override void PrintStats() {
+      for (int i = 0; i < sumReward.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return "UCBNormalPolicy";
+    }
   }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCTPolicy.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCTPolicy.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCTPolicy.cs	(revision 11730)
@@ -0,0 +1,70 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  /* Kocsis et al. Bandit based Monte-Carlo Planning */
+  public class UCTPolicy : BanditPolicy {
+    private readonly int[] tries;
+    private readonly double[] sumReward;
+    private int totalTries = 0;
+    private readonly double c;
+
+    public UCTPolicy(int numActions, double c = 1.0)
+      : base(numActions) {
+      this.tries = new int[numActions];
+      this.sumReward = new double[numActions];
+      this.c = c;
+    }
+
+    public override int SelectAction() {
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
+      foreach (var a in Actions) {
+        if (tries[a] == 0) return a;
+        var q = sumReward[a] / tries[a] + 2 * c * Math.Sqrt(Math.Log(totalTries) / tries[a]);
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = a;
+        }
+      }
+      return bestAction;
+    }
+    public override void UpdateReward(int action, double reward) {
+      Debug.Assert(Actions.Contains(action));
+      totalTries++;
+      tries[action]++;
+      sumReward[action] += reward;
+    }
+
+    public override void DisableAction(int action) {
+      base.DisableAction(action);
+      totalTries -= tries[action];
+      tries[action] = -1;
+      sumReward[action] = 0;
+    }
+
+    public override void Reset() {
+      base.Reset();
+      totalTries = 0;
+      Array.Clear(tries, 0, tries.Length);
+      Array.Clear(sumReward, 0, sumReward.Length);
+    }
+    public override void PrintStats() {
+      for (int i = 0; i < sumReward.Length; i++) {
+        if (tries[i] >= 0) {
+          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
+        } else {
+          Console.Write("{0,5}", "");
+        }
+      }
+      Console.WriteLine();
+    }
+    public override string ToString() {
+      return string.Format("UCTPolicy({0:F2})", c);
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs	(revision 11730)
@@ -17,10 +17,12 @@
     private readonly Random random;
     private readonly int contextLen;
+    private readonly Func<Random, int, IPolicy> policyFactory;
 
-    public AlternativesContextSampler(IProblem problem, int maxLen) {
+    public AlternativesContextSampler(IProblem problem, Random random, int maxLen, int contextLen, Func<Random, int, IPolicy> policyFactory) {
       this.maxLen = maxLen;
       this.problem = problem;
-      this.random = new Random(31415);
-      this.contextLen = 25;
+      this.random = random;
+      this.contextLen = contextLen;
+      this.policyFactory = policyFactory;
     }
 
@@ -29,6 +31,6 @@
       InitPolicies(problem.Grammar);
       for (int i = 0; i < maxIterations; i++) {
-        var sentence = SampleSentence(problem.Grammar);
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen); 
+        var sentence = SampleSentence(problem.Grammar).ToString();
+        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
         DistributeReward(quality);
 
@@ -45,4 +47,5 @@
     private Dictionary<string, IPolicy> ntPolicy;
     private List<Tuple<string, int>> updateChain;
+
     private void InitPolicies(IGrammar grammar) {
       this.ntPolicy = new Dictionary<string, IPolicy>();
@@ -50,16 +53,15 @@
     }
 
-    private string SampleSentence(IGrammar grammar) {
+    private Sequence SampleSentence(IGrammar grammar) {
       updateChain.Clear();
-      return CompleteSentence(grammar, grammar.SentenceSymbol.ToString());
+      return CompleteSentence(grammar, new Sequence(grammar.SentenceSymbol));
     }
 
-    public string CompleteSentence(IGrammar g, string phrase) {
+    public Sequence CompleteSentence(IGrammar g, Sequence phrase) {
       if (phrase.Length > maxLen) throw new ArgumentException();
       if (g.MinPhraseLength(phrase) > maxLen) throw new ArgumentException();
-      bool done = phrase.All(g.IsTerminal); // terminal phrase means we are done
+      bool done = phrase.IsTerminal; // terminal phrase means we are done
       while (!done) {
-        int ntIdx; char nt;
-        Grammar.FindFirstNonTerminal(g, phrase, out nt, out ntIdx);
+        char nt = phrase.FirstNonTerminal;
 
         int maxLenOfReplacement = maxLen - (phrase.Length - 1); // replacing aAb with maxLen 4 means we can only use alternatives with a minPhraseLen <= 2
@@ -67,5 +69,5 @@
 
         var alts = g.GetAlternatives(nt);
-        string selectedAlt;
+        Sequence selectedAlt;
         // if the choice is restricted then one of the allowed alternatives is selected randomly
         if (alts.Any(alt => g.MinPhraseLength(alt) > maxLenOfReplacement)) {
@@ -76,10 +78,11 @@
         } else {
           // all alts are allowed => select using bandit policy
+          var ntIdx = phrase.FirstNonTerminalIndex;
           var startIdx = Math.Max(0, ntIdx - contextLen);
           var endIdx = Math.Min(startIdx + contextLen, ntIdx);
-          var lft = phrase.Substring(startIdx, endIdx - startIdx + 1);
+          var lft = phrase.Subsequence(startIdx, endIdx - startIdx + 1).ToString();
           lft = problem.Hash(lft);
           if (!ntPolicy.ContainsKey(lft)) {
-            ntPolicy.Add(lft, new UCB1TunedPolicy(g.GetAlternatives(nt).Count()));
+            ntPolicy.Add(lft, policyFactory(random, g.GetAlternatives(nt).Count()));
           }
           var selectedAltIdx = ntPolicy[lft].SelectAction();
@@ -89,8 +92,7 @@
 
         // replace nt with alt
-        phrase = phrase.Remove(ntIdx, 1);
-        phrase = phrase.Insert(ntIdx, selectedAlt);
+        phrase.ReplaceAt(phrase.FirstNonTerminalIndex, 1, selectedAlt);
 
-        done = phrase.All(g.IsTerminal); // terminal phrase means we are done
+        done = phrase.IsTerminal; // terminal phrase means we are done
       }
       return phrase;
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs	(revision 11730)
@@ -27,6 +27,6 @@
       InitPolicies(problem.Grammar);
       for (int i = 0; i < maxIterations; i++) {
-        var sentence = SampleSentence(problem.Grammar);
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen); 
+        var sentence = SampleSentence(problem.Grammar).ToString();
+        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
         DistributeReward(quality);
 
@@ -52,16 +52,15 @@
     }
 
-    private string SampleSentence(IGrammar grammar) {
+    private Sequence SampleSentence(IGrammar grammar) {
       updateChain.Clear();
-      return CompleteSentence(grammar, grammar.SentenceSymbol.ToString());
+      return CompleteSentence(grammar, new Sequence(grammar.SentenceSymbol));
     }
 
-    public string CompleteSentence(IGrammar g, string phrase) {
+    public Sequence CompleteSentence(IGrammar g, Sequence phrase) {
       if (phrase.Length > maxLen) throw new ArgumentException();
       if (g.MinPhraseLength(phrase) > maxLen) throw new ArgumentException();
-      bool done = phrase.All(g.IsTerminal); // terminal phrase means we are done
+      bool done = phrase.IsTerminal; // terminal phrase means we are done
       while (!done) {
-        int ntIdx; char nt;
-        Grammar.FindFirstNonTerminal(g, phrase, out nt, out ntIdx);
+        char nt = phrase.FirstNonTerminal;
 
         int maxLenOfReplacement = maxLen - (phrase.Length - 1); // replacing aAb with maxLen 4 means we can only use alternatives with a minPhraseLen <= 2
@@ -69,5 +68,5 @@
 
         var alts = g.GetAlternatives(nt);
-        string selectedAlt;
+        Sequence selectedAlt;
         // if the choice is restricted then one of the allowed alternatives is selected randomly
         if (alts.Any(alt => g.MinPhraseLength(alt) > maxLenOfReplacement)) {
@@ -84,8 +83,7 @@
 
         // replace nt with alt
-        phrase = phrase.Remove(ntIdx, 1);
-        phrase = phrase.Insert(ntIdx, selectedAlt);
+        phrase.ReplaceAt(phrase.FirstNonTerminalIndex, 1, selectedAlt);
 
-        done = phrase.All(g.IsTerminal); // terminal phrase means we are done
+        done = phrase.IsTerminal; // terminal phrase means we are done
       }
       return phrase;
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveBreadthFirstSearch.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveBreadthFirstSearch.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveBreadthFirstSearch.cs	(revision 11730)
@@ -11,5 +11,5 @@
 
     private readonly int maxLen;
-    private readonly Queue<string> bfsQueue = new Queue<string>();
+    private readonly Queue<Sequence> bfsQueue = new Queue<Sequence>();
     private readonly IProblem problem;
 
@@ -21,10 +21,10 @@
     public void Run(int maxIterations) {
       double bestQuality = double.MinValue;
-      bfsQueue.Enqueue(problem.Grammar.SentenceSymbol.ToString());
+      bfsQueue.Enqueue(new Sequence(problem.Grammar.SentenceSymbol));
       var sentences = GenerateLanguage(problem.Grammar);
       var sentenceEnumerator = sentences.GetEnumerator();
       for (int i = 0; sentenceEnumerator.MoveNext() && i < maxIterations; i++) {
-        var sentence = sentenceEnumerator.Current;
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen); 
+        var sentence = sentenceEnumerator.Current.ToString();
+        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
         RaiseSolutionEvaluated(sentence, quality);
 
@@ -37,15 +37,16 @@
 
     // create sentences lazily
-    private IEnumerable<string> GenerateLanguage(IGrammar grammar) {
+    private IEnumerable<Sequence> GenerateLanguage(IGrammar grammar) {
       while (bfsQueue.Any()) {
         var phrase = bfsQueue.Dequeue();
 
-        char nt;
+        char nt = phrase.FirstNonTerminal;
         int ntIdx;
-        Grammar.FindFirstNonTerminal(grammar, phrase, out nt, out ntIdx);
+
         var alts = grammar.GetAlternatives(nt);
         foreach (var alt in alts) {
-          var newPhrase = phrase.Remove(ntIdx, 1).Insert(ntIdx, alt);
-          if (newPhrase.All(grammar.IsTerminal) && newPhrase.Length <= maxLen) {
+          var newPhrase = new Sequence(phrase);
+          newPhrase.ReplaceAt(newPhrase.FirstNonTerminalIndex, 1, alt);
+          if (newPhrase.IsTerminal && newPhrase.Length <= maxLen) {
             yield return newPhrase;
           } else if (grammar.MinPhraseLength(newPhrase) <= maxLen) {
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveDepthFirstSearch.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveDepthFirstSearch.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveDepthFirstSearch.cs	(revision 11730)
@@ -11,17 +11,19 @@
 
     private readonly int maxLen;
-    private readonly Stack<string> stack = new Stack<string>();
+    private readonly Stack<Sequence> stack = new Stack<Sequence>();
+    private readonly IProblem problem;
 
-    public ExhaustiveDepthFirstSearch(int maxLen) {
+    public ExhaustiveDepthFirstSearch(IProblem problem, int maxLen) {
       this.maxLen = maxLen;
+      this.problem = problem;
     }
 
-    public void Run(IProblem problem, int maxIterations) {
+    public void Run(int maxIterations) {
       double bestQuality = double.MinValue;
-      stack.Push(problem.Grammar.SentenceSymbol.ToString());
+      stack.Push(new Sequence(problem.Grammar.SentenceSymbol));
       var sentences = GenerateLanguage(problem.Grammar);
       var sentenceEnumerator = sentences.GetEnumerator();
       for (int i = 0; sentenceEnumerator.MoveNext() && i < maxIterations; i++) {
-        var sentence = sentenceEnumerator.Current;
+        var sentence = sentenceEnumerator.Current.ToString();
         var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
         RaiseSolutionEvaluated(sentence, quality);
@@ -35,15 +37,15 @@
 
     // create sentences lazily
-    private IEnumerable<string> GenerateLanguage(IGrammar grammar) {
+    private IEnumerable<Sequence> GenerateLanguage(IGrammar grammar) {
       while (stack.Any()) {
         var phrase = stack.Pop();
 
-        char nt;
-        int ntIdx;
-        Grammar.FindFirstNonTerminal(grammar, phrase, out nt, out ntIdx);
+        char nt = phrase.FirstNonTerminal;
         var alts = grammar.GetAlternatives(nt);
         foreach (var alt in alts) {
-          var newPhrase = phrase.Remove(ntIdx, 1).Insert(ntIdx, alt);
-          if (newPhrase.All(grammar.IsTerminal) && newPhrase.Length <= maxLen) {
+          var newPhrase = new Sequence(phrase);
+          newPhrase.ReplaceAt(newPhrase.FirstNonTerminalIndex, 1, alt);
+
+          if (newPhrase.IsTerminal && newPhrase.Length <= maxLen) {
             yield return newPhrase;
           } else if (grammar.MinPhraseLength(newPhrase) <= maxLen) {
